package it.andynaz.utils;

import java.io.*;
import java.util.regex.*;

/**
 * Metodi utili per una elementare gestione di file XML.
 * 
 * Per leggere e scrivere i file, &egrave; possibile utilizzare i metodi della
 * classe <tt>it.andynaz.utils.UtilsIO</tt>.
 * 
 * @author andynaz
 * @version 0.1 2012/07/14
 */
public class UtilsXML{
	//TODO metodo replaceTag(String fileContent, String tag, String content) - e metodi del tipo replaceTag(String fileContent, String tag, int content)...
	/**
	 * Rimpiazza il contenuto di un tag in un file XML.
	 * 
	 * &Egrave; necessario che il tag sia gi&agrave; presente nel file.
	 * 
	 * @param file file XML
	 * @param tag nome del tag
	 * @param content nuovo contenut del tag
	 */
	public static void replaceTag(File file, String tag, String content){
		try{
			String fileContent = UtilsIO.readFromFile(file).toString();
			fileContent = fileContent.replaceFirst("<"+tag+">.+</"+tag+">", "<"+tag+">"+content+"</"+tag+">");
			UtilsIO.writeToFile(file, fileContent);
		} catch(FileNotFoundException e){
			Utils.printException("PDFItem::getManifestContent", e);
		}
	}
	
	/**
	 * Legge il contenuto di un tag da un file XML.
	 * 
	 * @param file file XML
	 * @param tag nome del tag
	 * @return il contenuto del tag (o una stringa vuota se il file o il
	 *   tag non vengono trovati)
	 */
	public static String readTag(File file, String tag){
		String tagContent = "";
		try{
			StringBuilder content = UtilsIO.readFromFile(file);
			if( content==null || content.length()==0 )
				return "";
			Pattern p = Pattern.compile("<"+tag+">.+</"+tag+">");
			Matcher m = p.matcher(content);
			if( m.find() ){
				int l = tag.length();
			//	dLog("readTag", "tag="+tag+", content="+m.group().substring(11, m.group().length()-12));
				// elimina i tag <tag> e </tag>
				tagContent = m.group().substring(l+2, m.group().length()-l-3);
			}
		} catch(FileNotFoundException e){
			Utils.printException("readTag", e);
		} finally{
			return tagContent;
		}
	}
}
